#include "cmd.h"
#include "hardw.h"
#include "vars.h"
#include "fnn.h"

#define CE F_4
#define CS F_1

/* -------------------2708 routines----------------------- */

char ch2708_init(char c)
{
  F_10 = 1;
  SetF(F_12, 0);
  CS = 0;
}

char ch2708_read(char c)
{
  PPA2[KB] = 0xff;
  CS = 0;
  c = PPA2[KA];
  CS = 1;
  return(c);
}

char ch2708_write(char c)
{
  if (! Switch_Off)
  {
    PPA2[KB] = c;
    P1 = 2;         /* F_0="0", F_1="1", CS=12B */
    for (cnt = 299; cnt > 0; cnt--)
    {
      delay10us(1);
      set_Upp0(Upp);
      delay1ms(1);
      set_Upp0(Upp_0);
    }
    P1 = 1;        /* F_0="1", F_1="0", CS=0B */
    return(1);
  }
  else
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
    return(0);
  }
}

/* -------------------2716 routines----------------------- */

char ch2716_set_Upr(char c)
{
  if (c) F_9 = 0;
  else
  {
    SetF(F_13, 0);
    F_9 = 1;
    SetF(F_13, 1);
  }
}

char ch2716_wr_pins(char c)
{
  CE = 1;
  delay1ms(c);
  CE = 0;
}

/* -------------------2732 routines----------------------- */

char ch2732_set_Upr(char c)
{
  if (c) F_10 = 0;
  else
  {
    SetF(F_12, 0);
    F_10 = 1;
    SetF(F_12, 1);
  }
}

char ch2732_set_addr(char c)
{
  set_address(0);
  if (msg.cmd.address.lc.LO_HI_CHAR & 8) SetF(F_13, 1);
  else SetF(F_13, 0);
  return(1);
}

/* -------------------2764 routines----------------------- */

char ch2764_set_addr(char c)
{
  PPA1[KA] = msg.cmd.address.lc.LO_LO_CHAR;
  PPA1[KB] = msg.cmd.address.lc.LO_HI_CHAR | 0x40; /* S14 = 1 (-PR = 1) */
  return(1);
}

char ch2764_wr_pins(char c)
{
  CE = 0;
  PPA1[KB] = PPA1[KB] & 0xBF;  /* S14 = 0 (-PR = 0)*/
  delay1ms(c);
  PPA1[KB] = PPA1[KB] | 0x40;  /* S14 = 1 (-PR = 1)*/
}

/* -------------------27128 routines----------------------- */

/* -------------------27256 routines----------------------- */

char ch27256_wr_pins(char c)
{
  CE = 0;
  delay10us(c);
  CE = 1;
}

/* -------------------27512 routines----------------------- */

char ch27512_set_addr(char c)
{
  set_address(0);
  if (msg.cmd.address.lc.LO_HI_CHAR & 0x80) SetF(F_13, 1);
  else SetF(F_13, 0);
  return(1);
}

/* -------------------27010 routines----------------------- */

char ch27010_set_Upr(char c)
{
  if (c) set_Upp2(Upp);
  else set_Upp2(Upp_5V);
}

char ch27010_wr_pins(char c)
{
  CE = 0;
  F_11 = 0;
  delay10us(c);
  F_11 = 1;
  CE = 1;
}

/* -------------------Common 27xx routines----------------------- */

char ch27xx_init(char c)
{
}

char ch27xx_set_Upr(char c)
{
  if (c) F_9 = 0;
  else
  {
    SetF(F_13, 0);
    F_9 = 1;
    SetF(F_13, 1);
  }
}

char ch27xx_read(char c)
{
  PPA2[KB] = 0xff;
  CE = 0;
  SetF(F_12, 0); /* F12 = 0 (-OE = 0) */
  c = PPA2[KA];
  SetF(F_12, 1); /* F12 = 1 (-OE = 1) */
  return(c);
}

char ch27xx_write(char c)
{
  if (! Switch_Off)
  {
    get_chip_data();
    for (; dat.count != 0; dat.count--)
    {
      PPA2[KB] = c;
      chip_set_Upr(Upp);
      chip_wr_pins(dat.time);
      chip_set_Upr(0);
      if (chip_read(1) == c)
      {
        chip_set_Upr(Upp);
        chip_wr_pins(dat.time);
        chip_wr_pins(dat.time);
        chip_wr_pins(dat.time);
        chip_set_Upr(0);
        return(1);
      }
    }
    msg.ans.ans = anError;
    msg.ans.err = erWrite;
  }
  else
  {
    msg.ans.ans = anError;
    msg.ans.err = erSwOff;
  }
  return(0);
}