enum errors                             /* Error codes */
  {erOk, erCfgNotFound, erCfgLine, erNoPort, erNoChip, erPort,
   erNoHandshake, erFileNotFound, erFileNotCreate, erFile, erEsc,
   erUnknownChip, erSwOff, erMode, erRead, erWrite, erNoWrite,
   erBadAddr, erVerify, erErase};

enum answers                            /* Answer codes */
  {anError, anOk, an_nums};

enum modes                              /* Mode  codes */
  {mHandshake=an_nums, mWrite, mRead, mErase_verify, mWrite_verify,
   mErase, mUErase, mVerify, mSet_Upr, mReset_Upr, mLock_Read,
   mLock_Write, mLock_Ex, mUWrite, mLoad, mRun, mReadRAM, mExec, mHelp};

enum erases                             /* Erase modes */
  {eErase, eUErase, eLockRead, eLockWrite, eLockEx};

typedef struct {
 unsigned int HI_WORD;
 unsigned int LO_WORD;
} slongword;

typedef struct {
 unsigned char HI_HI_CHAR;
 unsigned char HI_LO_CHAR;
 unsigned char LO_HI_CHAR;
 unsigned char LO_LO_CHAR;
} slongchar;

typedef union {
 unsigned long l;
 slongword lw;
 slongchar lc;
} longrec;

struct command                          /* Pkt message */
  {
    char mode;                          /* Programming mode */
    char chip;                          /* Chip type code */
    char info;
    longrec address;                    /* Programming address */
    unsigned long length;               /* Block length */
    unsigned char voltage;              /* Programming voltage */
    char count;                         /* Repetition count */
  };

struct answer                           /* Ans message */
  {
    char ans;                           /* Answer code */
    char err;                           /* Error code */
    char info;
    unsigned long address;              /* Programming address */
    unsigned long length;               /* Block length */
    unsigned char voltage;              /* Programming voltage */
    char count;                         /* Repetition count */
  };

union message                           /* Message declaration */
  {
    struct command cmd;                 /* Command record */
    struct answer ans;                  /* Answer record */
  };

extern union message msg;               /* Message global variable */

#define lo_byte(x) *((char *)&(x) + 1)
#define hi_byte(x) *((char *)&(x))