#include "xfer.h"
#include "cmd.h"
#include "hardw.h"

void init_setting(void)
{
  P1 = 0xff;
  F_8 = 1;
  F_9 = 1;
  F_10 = 1;
  F_11 = 1;
  PPA1[RUS] = OUTPUT;
  PPA2[RUS] = OUTPUT + INKA;
  PPA2[KB] = 0xff;
  PPA1[KC] = msg.cmd.voltage;
  PPA2[KC] = 0xf8;
  PPA1[KA] = 0xff;
  PPA1[KB] = 0xff;
}

char set_address(char c)
{
  PPA1[KA] = msg.cmd.address.lc.LO_LO_CHAR;
  PPA1[KB] = msg.cmd.address.lc.LO_HI_CHAR;
  return(1);  /* Needed to enable conditional write */
}

char set_Upp0(char c)
{
  if (c == Upp_0)
  {
    F_10 = 1;
    SetF(F_12, 0);
  }
  else if (c == Upp_5V)
  {
    F_10 = 1;
    SetF(F_12, 1);
  }
  else
  {
    F_10 = 0;
    SetF(F_12, 1);
  }
}

char set_Upp1(char c)
{
  if (c == Upp_0)
  {
    F_9 = 1;
    SetF(F_13, 0);
  }
  else if (c == Upp_5V)
  {
    F_9 = 1;
    SetF(F_13, 1);
  }
  else
  {
    F_9 = 0;
    SetF(F_13, 1);
  }
}

char set_Upp2(char c)
{
  if (c == Upp_0)
  {
    F_8 = 1;
    SetF(F_14, 0);
  }
  else if (c == Upp_5V)
  {
    F_8 = 1;
    SetF(F_14, 1);
  }
  else
  {
    F_8 = 0;
    SetF(F_14, 1);
  }
}

/*
F8  F14  Upp2
0   0    0
0   1    Upp
1   0    0
1   1    +5

F9  F13  Upp1
0   0    0
0   1    Upp
1   0    0
1   1    +5

F10 F12  Upp0
0   0    0
0   1    Upp
1   0    0
1   1    +5

F_0  F_1 Upr
0   0    0
0   1    Upr +15V
1   0    0
1   1    +5

F_2  Ucc
0    +12V
1    +5V
*/