#include <io51.h>

#define PPA1 ((char *) 0x014000)
#define PPA2 ((char *) 0x012000)
#define RAM ((char *) 0x010000)
#define RRAM ((char *) 0x020000)
#define RUS 3
#define KA 0
#define KB 1
#define KC 2
#define OUTPUT 0x80       /*  ;   뢮 */
#define INKA 0x10         /*  ; A       */
#define INKB 2            /*  ; B       */
#define INKC0 1           /*  ; C0      */
#define INKC1 8           /*  ; C1      */
#define F_0 P1.0
#define F_1 P1.1
#define F_2 P1.2
#define F_3 P1.3
#define F_4 P1.4
#define F_5 P1.5
#define F_6 P1.6
#define F_7 P1.7
#define F_8 P3.2
#define F_9 P3.3
#define F_10 P3.4
#define F_11 P3.5
#define F_12 0
#define F_13 2
#define F_14 4
#define F_15 6
#define F_16 8
#define F_17 10
#define F_18 12
#define F_19 14

#define SetF(f, c) PPA2[RUS] = f + c  /* ⠭ F_12..F_19  0  1 */

#define Switch_Off F_7                /* 㬡 Upr */

void delay1ms(char cnt);              /* Code in ASMPROCS.S03 */
void delay10us(char cnt);             /* Code in ASMPROCS.S03 */
void delay1s(char cnt);               /* Code in ASMPROCS.S03 */

void init_setting(void);

char set_address(char c);

enum {Upp_0, Upp_5V, Upp};

char set_Upp0(char c);
char set_Upp1(char c);
char set_Upp2(char c);

/*
F8  F14  Upp2
0   0    0
0   1    Upp
1   0    0
1   1    +5

F9  F13  Upp1
0   0    0
0   1    Upp
1   0    0
1   1    +5

F10 F12  Upp0
0   0    0
0   1    Upp
1   0    0
1   1    +5

F_0  F_1 Upr
0   0    0
0   1    Upr +15V
1   0    0
1   1    +5
*/