#include "xfer.h"
#include <stdio.h>

/* Send single packet */
signed char send_pkt(char * pkt, signed char length, char address)
{
  unsigned char chk;                    /* Checksum local variable */
  signed char l;
  l = length;
  putchar(DLE);                         /* Send starting char */
  putchar(length);                      /* Send pkt length */
  putchar(address);                     /* Send address */
                                        /* Initialize checksum */
  for(chk = 0 ; length > 0; length --)  /* Loop */
    {
      putchar(*pkt);                    /* Send pkt char */
      chk += *pkt++;                    /* Increment checksum and pos */
    }
  putchar(chk);                         /* Send checksum */
  if (getchar() == ACK) return(l);      /* Receive acknowledgment */
  else return(-1);                      /* Return FALSE on error */
}

/* Receive single packet */
signed char receive_pkt(char * pkt, signed char length)
{
  unsigned char chk;                    /* Checksum local variable */
  signed char l;
  signed char len;                      /* Length local variable */
  char addr;                            /* Address local variable */

  if (getchar() == DLE)                 /* Receive starting char */
    {
      l = len = getchar();              /* Receive length */
      if (len <= length)                /* Check length validity */
        {
          addr = getchar();             /* Receive address */
                                        /* Initialize checksum */
          for(chk = 0; len > 0; len--)  /* Loop */
            {
              *pkt = getchar();         /* Receive pkt char */
              chk += *pkt++;            /* Increment checksum and pos */
            };
          if (getchar() == chk)         /* Receive and compare checksum */
            {
              putchar(ACK);             /* Send acknowledgment */
              return(l);                /* Return TRUE */
            };
        };
    };
  putchar(NAK);                         /* Send non-acknowledgment */
  return(-1);                           /* Return FALSE on error */
}