{$A+,B+,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y-}
{$M 16384,0,655360}

Program Jed2Bin;
uses Memory, Objects, tpString, Revpos, GetID, Dos;
type
 TMode = (JedWrite, JedCompare, JedCompAll, JedRead, JedTest,
          JedIsEmpty, Help);

const
 Digits: Set of char = ['0'..'9', 'A' .. 'F'];
 Points: Set of char = ['.','-'];

var
 PJedec, PBin, PAddrs: PbyteArray;
 JedecSize : Word;
 Device, MapName, JedName, BinName: String[79];
 Security : Byte;
 Mode : TMode;
 DevOut : Boolean;

const
 FullHex: Boolean = True;
 JedLine: Word = 40;
 Pin: Word = 0;

procedure Realloc(Var P: Pointer; OldSize, NewSize : Word);
var
 PP: Pointer;
begin
 PP := MemAlloc(NewSize);
 if PP <> Nil then
  begin
   Move(P^, PP^, NewSize);
   FreeMem(P, OldSize);
   P := PP;
  end;
end;

function InWordSet(var WSet; Addr: Word): Byte;
var
 B, i: byte;
begin
 i := 7 - Addr mod 8;
 B := TByteArray(WSet)[Addr div 8] shr i;
 InWordSet := B and 1;
end;

procedure PutWordSet(var WSet; Addr: Word; Value: Byte);
var
 B, i: byte;
 A : Word;
begin
 i := 7 - Addr mod 8;
 A := Addr div 8;
 B := Value shl i;
 if Value = 1 then
  TByteArray(WSet)[A] := TByteArray(WSet)[A] or B
 else
  TByteArray(WSet)[A] := TByteArray(WSet)[A] and not B;
end;

procedure ReadJedec(const JedName: String; Var Device: String);
var
 Jed: PBufStream;
 Ch: Char;
 JedAddr: Word;
 B, i, ps : Byte;
 S : String;
begin
 JedAddr := 0; S := ''; Security := 0; Device := '';
 Jed := New(PBufStream,Init(JedName, stOpenRead, 4096));
 if Jed^.Status <> stOk then
  begin
   WriteLn('File ', JedName, ' not found.');
   Halt;
  end;
 Jed^.Read(Ch, 1);
 if Ch = #2 then
  repeat
   Jed^.Read(Ch, 1);
   if Ch = #9 then Ch := ' ';
   if Ch in ['*', #10, #13] then
    begin
     ps := pos(';', S);
     if ps <> 0 then Delete(S, ps, 255);
     if Pos('N PART:', S) = 1 then Device := Trim(Copy(S, 8, 255));
     if S = 'G1' then  Security := 1; {!!!!!!}
     S := '';
     Jed^.Read(Ch, 1);
     if Ch = 'L' then
      begin
       Jed^.Read(Ch, 1);
       Jed^.Seek(Jed^.GetPos - 1);
       if Ch in ['0'..'9'] then
        begin
         JedAddr := 0;
         repeat
          Jed^.Read(Ch, 1);
          if Ch in ['0'..'9'] then JedAddr := JedAddr * 10 + (Byte(Ch) - $30);
         until not (Ch in ['0'..'9']);
         repeat
          Jed^.Read(Ch, 1);
          if ch in ['0', '1'] then
           begin
            PutWordSet(PJedec^, JedAddr, Byte(Ch) - $30);
            Inc(JedAddr);
           end;
         until Ch = '*';
         Jed^.Seek(Jed^.GetPos - 1);
        end
       else Jed^.Seek(Jed^.GetPos - 1);
      end
     else Jed^.Seek(Jed^.GetPos - 1)
    end
   else S := S + Ch;
  until Jed^.Status <> stOk;
 PutWordSet(PJedec^, JedAddr, Security);
 Inc(JedAddr);
 JedecSize := JedAddr;
 Dispose(Jed, Done);
end;

procedure GetRange(Const S: String; R: Char; var r0, r1: word; var ps: byte);
var
 Code: Integer;
 SS : String;
begin
  SS := Trim(R + GetRightId(S, Digits, Ps));
  Val(SS, r0, Code);
  SS := GetRightId(S, Points, Ps);
  if SS = '' then r1 := r0
  else
   begin
    SS := Trim(R + GetRightId(S, Digits, Ps));
    Val(SS, r1, Code);
   end;
end;

procedure GetOptioinal(const S: String; const Key: String; var Opt: String);
var
 ps: Byte;
begin
 ps := Pos(Key, S);
 if Ps <> 0 then Opt := Copy(S, ps + Length(Key), 255);
end;

function WVal(W : Longint; Const S : String) : Longint;
var
 I, J : word;
 L : Longint;
 Sign : Boolean;
 SS : String;
begin
 L := 0; Sign := False;
 J := Length(S);
 if J > 32 then J := 32;
 for I := 1 to J do
  begin
   if S[i] in ['0'..'9'] then
     L := L or (W shr (i-1) and 1) shl (Byte(S[i]) - Byte('0'))
   else
   if S[i] in ['A'..'V'] then
     L := L or (W shr (i-1) and 1) shl (Byte(S[i]) - Byte('A') + $A)
   else
   if S[i] = '-' then
     Sign := (W shr (i-1) and 1) <> 0
   else
   if S[i] = '!' then
     Sign := (not(W) shr (i-1) and 1) <> 0
  end;
 if Sign then L := ($FFFFFFFF shl i) or L  or (1 shl (i - 1));
 WVal := L;
end;

procedure ReadMap(const MapName, BinName: String; Mode : TMode);
var
 ps, ph, pd, i, v: byte;
 T: Text;
 O: File;
 Radix: String[4];
 AddrMap, DataMap: String[16];
 S, SS : String;
 Code: Integer;
 JedAddr, BinAddr, Row, Column, Data: Word;
 BinSize, AddrsSize, ByteCount: Word;
 b0, b1, r0, r1, c0, c1 : word;
 b, r, c, d, tt: word;
 State: (FindDevice, FindAddr, FindRadix, Compile, OutOfMemory,
         C_OutOfRange, R_OutOfRange, D_OutOfRange, J_OutOfRange,
         B_OutOfRange, NotEqual, stRead, HexErr, Done);

  procedure HexWrite(var T: Text);
  var
   Addr: Word;
   HexLen, CheckSum: Byte;
   S: String;
  begin
   Addr := 0; ByteCount := 0;
   while Addr < BinSize do
    begin
     if ((PBin^[Addr] <> 0) or FullHex) and
        (InWordSet(PAddrs^, Addr) = 1) then
      begin
       HexLen := 0;
       CheckSum := Lo(Addr) + Hi(Addr);
       S :=  HexW(Addr) + '00';
       while ((PBin^[Addr] <> 0) or FullHex) and
             (InWordSet(PAddrs^, Addr) = 1) and
             (HexLen < 16) do
        begin
         S := S + HexB(PBin^[Addr]);
         inc(CheckSum, PBin^[Addr]);
         inc(HexLen);
         inc(Addr);
         inc(ByteCount);
        end;
       inc(CheckSum, HexLen);
       Insert(':' + HexB(HexLen), S, 1);
       S := S + HexB(-CheckSum);
       WriteLn(T, S);
      end
     else inc(Addr);
    end;
   WriteLn(T, ':00000001FF');
  end;

  function HexChar(Ch: Char): Byte;
  begin
   HexChar := 0;
   if Ch in ['0'..'9'] then HexChar := Byte(Ch) - $30
   else if Ch in ['A'..'F'] then HexChar := Byte(Ch) - $37
        else if Ch in ['a'..'f'] then HexChar := Byte(Ch) - $57
             else State := HexErr;
  end;

  function GetHexByte(Var S: String) : Byte;
   begin
    GetHexByte := HexChar(S[1]) shl 4 + HexChar(S[2]);
    Delete(S, 1, 2);
   end;

  procedure HexRead(var T: Text);
  var
   Addr: Word;
   HexLen, CheckSum, HexType, i, b: Byte;
   S: String;
  begin
   while not eof(T) do
    begin
     ReadLn(T, S);
     if S[1] <> ':' then State := HexErr;
     case State of
      stRead:
       begin
        Delete(S, 1, 1);
        HexLen := GetHexByte(S);
        Addr := GetHexByte(S);
        Addr := Addr shl 8 + GetHexByte(S);
        HexType := GetHexByte(S);
        CheckSum := HexLen + Lo(Addr) + Hi(Addr) + HexType;
        if HexType = 1 then State := FindDevice
        else
         begin
          for i := 0 to HexLen -1 do
           begin
            PBin^[Addr] := GetHexByte(S);
            inc(CheckSum, PBin^[Addr]);
            inc(Addr);
           end;
          BinSize := Addr;
         end;
        Inc(CheckSum, GetHexByte(S));
        if CheckSum <> 0 then State := HexErr;
       end;
     end; {case}
    end;
  end;

begin
 State := stRead;
 if Mode in [JedCompare, JedCompAll, JedRead] then
  if Pos('.HEX', StUpCase(BinName)) <> 0 then
   begin
    Assign(T, BinName);
    Reset(T);
    if IOResult <> 0 then
     begin
      WriteLn('ERROR: ', BinName, ' not found.');
      Halt;
     end;
    PBin := MemAlloc($7fff);
    if PBin <> Nil then
     begin
      FillChar(PBin^, $7fff, 0);
      HexRead(T);
      Realloc(Pointer(PBin), $7fff, BinSize);
     end;
    Close(T);
    if State = HexErr then WriteLn('ERROR: Hex file ',BinName, ' corrupted.')
    else WriteLn('Read ',BinSize, ' byte from ', BinName, '.');
   end
  else
   begin
    Assign(O, BinName);
    Reset(O, 1);
    if IOResult <> 0 then
     begin
      WriteLn('ERROR: File ', BinName, 'not found.');
      Halt;
     end;
    BinSize := FileSize(O);
    PBin := MemAlloc(BinSize);
    if PBin <> Nil then
     begin
      WriteLn('Reading ', BinSize, ' byte from ', BinName, '.');
      BlockRead(O, PBin^,  BinSize);
      State := FindDevice;
     end
    else State := OutOfMemory;
    Close(O);
   end
 else State := FindDevice;

 Assign(T, MapName);
 Reset(T);
 if IOResult <> 0 then
  begin
   WriteLn('ERROR: File ', MapName, ' not found.');
   Halt;
  end;
 Row := 0; Column := 0; Data := 0;
 Radix := '    ';
 AddrMap := '0123456789ABCDEF';
 DataMap := '0123456789ABCDEF';
 while not eof(T) do
  begin
   ReadLn(T, S);
   ps := pos(';', S);
   if ps <> 0 then Delete(S, ps, 255);
   if S = '' then Continue;
   S := Trim(StUpCase(S));
   GetOptioinal(S, 'ADDRMAP:', AddrMap);
   GetOptioinal(S, 'DATAMAP:', DataMap);
   case State of
    FindDevice:
     begin
      ps := pos('DEVICE:', S);
      if (ps <> 0) and (Pos(Device, S) > ps) then State := FindAddr;
     end;
    FindAddr:
     begin
      ps := Pos('ROW:', S);
      if ps <> 0 then
        begin
         inc(ps, 3);
         GetRange(S, ' ', Row, r1, ps);
        end;

      ps := Pos('COLUMN:', S);
      if ps <> 0 then
        begin
         inc(ps, 6);
         GetRange(S, ' ', Column, r1, ps);
        end;

      ps := Pos('DATA:', S);
      if ps <> 0 then
        begin
         inc(ps, 4);
         GetRange(S, ' ', Data, r1, ps);
        end;

      ps := Pos('JEDLINE:', S);
      if ps <> 0 then
        begin
         inc(ps, 7);
         GetRange(S, ' ', JedLine, r1, ps);
        end;

      ps := Pos('PIN:', S);
      if ps <> 0 then
        begin
         inc(ps, 3);
         GetRange(S, ' ', Pin, r1, ps);
        end;

      if (Row <> 0) and (Column <> 0) and (Data <> 0) then
       begin
        if Data > 8 then BinSize := (1 shl (Row + Column)) * 2
        else BinSize := 1 shl (Row + Column);
        AddrsSize := 1 shl (Row + Column);

        if Mode = JedWrite then
         begin
          PAddrs := MemAlloc($3fff);
          if PAddrs = Nil then State := OutOfMemory
          else FillChar(PAddrs^, $3fff, 0);

          PBin := MemAlloc(BinSize);
          if PBin <> Nil then
           begin
            FillChar(PBin^, BinSize, 0);
            State := FindRadix;
           end
          else State := OutOfMemory;
         end
        else State := FindRadix;

       end;
     end;
    FindRadix:
     begin
      ps := Pos('RADIX:', S);
      if ps <> 0 then
        begin
         for i := 1 to 4 do
          begin
           ph := FIPos('HEX',S, ps);
           if ph = 0 then ph := 255;
           pd := FIPos('DEC',S, ps);
           if pd = 0 then pd := 255;
           if ph < pd then
            begin
             ps := ph;
             Radix[i] := '$';
            end
           else
            begin
             ps := pd;
             Radix[i] := ' ';
            end;
          end;
         State := Compile;
        end;
     end;
    Compile:
     begin
      if Pos('END', S) <> 0 then State := Done;
      Ps := 0;
      if Pos('V', S) = 1 then
       begin
        if Mode <> JedRead then JedAddr := JedecSize - 1
        else JedAddr := $ffff;
        inc(ps,2);
       end
      else GetRange(S, Radix[1], JedAddr, r1, ps);
      GetRange(S, Radix[2], c0, c1, ps);
      if (c0 > 1 shl Column) or
         (c1 > 1 shl Column) then State := C_OutOfRange;
      GetRange(S, Radix[3], r0, r1, ps);
      if (r0 > 1 shl Row) or
         (r1 > 1 shl Row) then State := R_OutOfRange;
      GetRange(S, Radix[4], b0, b1, ps);
      if (b0 > 1 shl Data) or
         (b1 > 1 shl Data) then State := D_OutOfRange;
      for c:= c0 to c1 do
       for r:= r0 to r1 do
        for b:= b0 to b1 do
         begin
          if State <> Compile then Break;
          BinAddr := {WVal(}r or c shl Row{, AddrMap)};
          case Mode of
           JedWrite:
            begin
             PutWordSet(PAddrs^, BinAddr, 1);
             if JedAddr >= JedecSize then  State := J_OutOfRange;
             d := Word(InWordSet(PJedec^, JedAddr)) shl b;
             if Data > 8 then
              TWordArray(PBin^)[BinAddr] := TWordArray(PBin^)[BinAddr] or d
             else
              PBin^[BinAddr] := PBin^[BinAddr] or d;
             inc(JedAddr);
            end;
           JedCompare,
           JedCompAll:
            begin
             if (BinAddr * (Data div 9 + 1)) < BinSize then
              begin
               if JedAddr >= JedecSize then State := J_OutOfRange;
               d := Word(InWordSet(PJedec^, JedAddr)) shl b;
               tt := 1 shl b;
               if Data > 8 then
                begin
                 if (TWordArray(PBin^)[BinAddr] and tt) <> d then State := NotEqual;
                end
               else
                begin
                 if (PBin^[BinAddr] and tt) <> d then {State := NotEqual;}
                  begin
                   if Mode = JedCompAll then
                    begin
                     WriteLn('ERROR: Compare filed at jed address: ',
                             JedAddr, ' (', HexW(JedAddr),
                             'H) bin address: ', HexW(BinAddr), '.');
                     WriteLn('Column: ', HexB(c), ', Row: ', HexB(r),
                             ', Data bit: ', HexB(b), ', Bin value: ',
                             PBin^[BinAddr] shr b and 1, ', JEDEC value: ',
                             InWordSet(PJedec^, JedAddr));
                    end
                   else State := NotEqual;
                  end;
                end;
               inc(JedAddr);
              end
             else State := B_OutOfRange;
            end;
           JedRead:
            begin
             Security := 0;
             if (BinAddr * (Data div 9 + 1)) < BinSize then
              begin
               tt := 1 shl b;
               if JedAddr <> $ffff then
                begin
                 if Data > 8 then
                   Boolean(V) := TWordArray(PBin^)[BinAddr] and tt <> 0
                 else
                   Boolean(V) := PBin^[BinAddr] and tt <> 0;
                 PutWordSet(PJedec^, JedAddr, V);
                 inc(JedAddr);
                 if JedecSize < JedAddr then JedecSize := JedAddr;
                end
               else Boolean(Security) :=  PBin^[BinAddr] and tt <> 0;
              end
             else State := B_OutOfRange;
            end;
          end {case}
         end;
     end;
    OutOfMemory,
    C_OutOfRange,
    R_OutOfRange,
    D_OutOfRange,
    J_OutOfRange,
    B_OutOfRange: Break;
   end; {case}
  end;
 Close(T);
 case State of
  Done:
   case Mode  of
    JedWrite:
     begin
      if Pos('.HEX', StUpCase(BinName)) <> 0 then
       begin
        if Data > 8 then
         begin
          WriteLn('ERROR: Can''t create HEX file for ', Data, ' bit data size');
          Halt;
         end;
        Assign(T, BinName);
        ReWrite(T);
        if IOResult <> 0 then
         begin
          WriteLn('ERROR: Cant''t create ', BinName);
          Halt;
         end;
        HexWrite(T);
        Close(T);
        WriteLn(ByteCount, ' byte of ', BinName, ' successfully created.');
       end
      else
       begin
        Assign(O, BinName);
        ReWrite(O, 1);
        if IOResult <> 0 then
         begin
          WriteLn('ERROR: Cant''t create ', BinName);
          Halt;
         end;
        BlockWrite(O, PBin^,  BinSize);
        Close(O);
        WriteLn(BinSize, ' byte of ', BinName, ' successfully created.');
       end;
      FreeMem(PAddrs, $3fff);
      FreeMem(PBin, BinSize);
     end;
    JedCompare:
     WriteLn('Compare passed.');
    JedRead:
     begin
      WriteLn(JedecSize,' bit reading from ', BinName, '.');
     end;
   end;
  NotEqual:
   begin
    WriteLn('ERROR: Compare filed at jed address: ', JedAddr - 1,
            ' (', HexW(JedAddr - 1), 'H) bin address: ', HexW(BinAddr), '.');
    WriteLn('Column: ', HexB(c), ', Row: ', HexB(r),  ', Data bit: ', HexB(b),
            ', Bin value: ', PBin^[BinAddr] shr b and 1, ', JEDEC value: ',
            InWordSet(PJedec^, JedAddr - 1));
   end;
  FindDevice:
    WriteLn('ERROR: Device ', Device, ' not found in ',MapName, '.');
  FindAddr:
    WriteLn('ERROR: ''Row:'' or ''Column:'' expected in ',MapName, '.');
  FindRadix:
    WriteLn('ERROR: ''Radix:'' expected in ',MapName, '.');
  Compile:
    WriteLn('ERROR: ''End'' expected in ',MapName, '.');
  OutOfMemory:
    WriteLn('ERROR: Out of memory.');
  C_OutOfRange:
    WriteLn('ERROR: Column address out of range.');
  R_OutOfRange:
    WriteLn('ERROR: Row address out of range.');
  D_OutOfRange:
    WriteLn('ERROR: Data bit number out of range.');
  J_OutOfRange,
  B_OutOfRange:
    WriteLn('ERROR: JEDEC address out of range.');
 end; {case}

end;

function Int2Str(I : Integer; n : byte) : String;
var
 b : byte;
 SSS : String;
Begin
 Str(i:n,SSS);
  for b := 1 to Length(SSS) do
   if SSS[b] = ' ' then SSS[b] := '0';
 Int2Str := SSS;
End;

function GetCurDateTime : String;
var
 Year, Month, Day, DayOfWeek : Word;
 Hour, Min, Sec, Sec100 : Word;
 SS : String;
begin
 SS := '';
 GetDate(Year, Month, Day, DayOfWeek);
 GetTime(Hour, Min, Sec, Sec100);
 SS := SS + Int2Str(Month,2);
 SS := SS + '-'+ Int2Str(Day,2);
 SS := SS + '-'+ Copy(Int2Str(Year,2),3,2);
 SS := SS + ' '+ Int2Str(Hour,2);
 SS := SS + ':'+ Int2Str(Min,2);
 SS := SS + ':'+ Int2Str(Sec,2);
 GetCurDateTime := SS;
end;

function IsEmpty: Boolean;
var
 JedAddr: Word;
 Empty: Boolean;
begin
 Empty:= True;
 for JedAddr := 0 to JedecSize - 1 do
  begin
   Empty := InWordSet(PJedec^, JedAddr) = 0;
   if not Empty then Break;
  end;
 IsEmpty := Empty;
end;

procedure JedWriting(const Name: String);
var
 JedAddr: Word;
 T: Text;
begin
 Assign(T, Name);
 ReWrite(T);
 WriteLn(T, #2'TITLE         FROM PROGRAMMATOR');
 WriteLn(T, 'PATTERN        PDS');
 WriteLn(T, 'REVISION       1');
 WriteLn(T, 'AUTHOR         PROGRAMMATOR');
 WriteLn(T, 'COMPANY        PROGRAMMATOR');
 WriteLn(T, 'DATE           ', GetCurDateTime);
 WriteLn(T, 'OPTIONS:');
 if InWordSet(PJedec^, JedecSize - 1) <> 0 then WriteLn(T, 'TURBO = ON')
 else WriteLn(T, 'TURBO = OFF');
 if Security = 0 then WriteLn(T, 'SECURITY = OFF')
 else WriteLn(T, 'SECURITY = ON');
 WriteLn(T, '*');
 WriteLn(T, 'N PART: ', Device, ' *');
 WriteLn(T, 'QP', Pin, '* QF', JedecSize, '*');
 WriteLn(T, 'G', Security, '*');
 WriteLn(T, 'L0');
 for JedAddr := 0 to JedecSize - 1 do
  begin
   Write(T, InWordSet(PJedec^, JedAddr));
   if (JedAddr + 1) mod Byte(JedLine) = 0 then WriteLn(T);
  end;
 WriteLn(T, '*');
 WriteLn(T, #3);
 Close(T);
 WriteLn(JedecSize, ' bit of ', Name, ' successfully created.');
end;

procedure ComString;
var
 PComString: PString;
 i, j : Byte;
begin
 Mode := JedWrite;
 PComString := Ptr(PrefixSeg, $80);
 i:= 1;
 while i < Length(PComString^)  do
  begin
   if (PComString^[i] in ['/', '-']) and
      ((i+2 >= Length(PComString^)) or
       (PComString^[i+2] = ' ')) then
    begin
     case PComString^[i+1] of
      'C'    : Mode := JedCompAll;
      'c'    : Mode := JedCompare;
      'W','w': Mode := JedWrite;
      'R','r': Mode := JedRead;
      'J','j': Mode := JedTest;
      'E','e': Mode := JedIsEmpty;
      '?'    : Mode := Help;
      'B','b': FullHex := False;
     end;
     Delete(PComString^, i, 2);
    end;
   inc(i);
  end;
end;

function IsDev(var T : text): boolean; assembler;
asm
 les di, T
 mov ax,$4400
 mov bx, es:[di]
 int 21h
 mov ax, dx
 and al,80h
end;

begin
 DevOut := IsDev(Output);
 WriteLn('JEDEC file to binary (HEX) converter');
 if DevOut then WriteLn('Jed2Bin [/C|/c|/W|/R|/?] [/B] {NAME.JED} {NAME.BIN | NAME.HEX} Device');
 ComString;
 if (Mode <> Help) and (ParamCount < 2) then
  begin
   WriteLn('ERROR: Missing argument');
   Halt;
  end;
 MapName := ParamStr(0);
 MapName := Copy(MapName, 1, Pos('.', MapName)) + 'PLD';
 if Mode <> JedIsEmpty then
  begin
   JedName := ParamStr(1);
   BinName := ParamStr(2);
   WriteLn('Jedec name: ', JedName);
   WriteLn('Binary (HEX) name: ', BinName);
  end
 else
  begin
   BinName := ParamStr(1);
   WriteLn('Binary (HEX) name: ', BinName);
  end;
 WriteLn;
 case Mode of
  JedWrite:
   WriteLn('Creation mode');
  JedCompare,
  JedCompAll:
   WriteLn('Compare mode');
  JedRead:
   WriteLn('Read mode');
  JedTest:
   WriteLn('Jed read test mode');
  JedIsEmpty:
   WriteLn('Empty test mode');
  Help:
   begin
    WriteLn('/c       Stop compare on first error');
    WriteLn('/C       Compare all bits');
    WriteLn('/W /w    Create bin (.HEX) file');
    WriteLn('/B /b    Brief hex mode');
    WriteLn('/R /r    Create jed file from bin (HEX)');
    WriteLn('/E /e    Empty test');
   end;
 end;
 case Mode of
  JedWrite,
  JedCompare,
  JedCompAll:
   begin
    PJedec := MemAlloc($3fff);
    FillChar(PJedec^,$3fff, 0);
    Write('Reading ', JedName, ' ');
    ReadJedec(JedName, Device);
    WriteLn(JedecSize, ' bit of ', Device, ' JEDEC file');
    Realloc(Pointer(PJedec), $3fff, JedecSize div 8 + 1);
    ReadMap(MapName, BinName, Mode);
    FreeMem(PJedec, JedecSize);
   end;
  JedRead:
   begin
    JedecSize := 0;
    Device := StUpCase(ParamStr(3));
    PJedec := MemAlloc($3fff);
    FillChar(PJedec^,$3fff, 0);
    ReadMap(MapName, BinName, Mode);
    JedWriting(JedName);
    FreeMem(PJedec, $3fff);
   end;
  JedTest:
   begin
    PJedec := MemAlloc($3fff);
    FillChar(PJedec^,$3fff, 0);
    Write('Reading ', JedName, ' ');
    ReadJedec(JedName, Device);
    WriteLn(JedecSize, ' bit of ', Device, ' JEDEC file');
    Realloc(Pointer(PJedec), $3fff, JedecSize div 8 + 1);
    JedWriting(BinName);
   end;
  JedIsEmpty:
   begin
    Device := StUpCase(ParamStr(2));
    PJedec := MemAlloc($3fff);
    FillChar(PJedec^,$3fff, 0);
    ReadMap(MapName, BinName, JedRead);
    if IsEmpty then WriteLn(Device, ' is empty.')
    else WriteLn(Device, ' is not empty.');
    FreeMem(PJedec, $3fff);
   end;
 end;
end.